# coding: utf-8

"""
Copyright (c) 2022 Aspose.Cells Cloud
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
"""


from pprint import pformat
from six import iteritems
import re


class ListColumn(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'totals_calculation': 'str',
        'name': 'str',
        'formula': 'str',
        'range': 'Range'
    }

    attribute_map = {
        'totals_calculation': 'TotalsCalculation',
        'name': 'Name',
        'formula': 'Formula',
        'range': 'Range'
    }
    
    @staticmethod
    def get_swagger_types():
        return ListColumn.swagger_types
    
    @staticmethod
    def get_attribute_map():
        return ListColumn.attribute_map
    
    def get_from_container(self, attr):
        if attr in self.container:
            return self.container[attr]
        return None

    def __init__(self, totals_calculation=None, name=None, formula=None, range=None, **kw):
        """
        Associative dict for storing property values
        """
        self.container = {}
		    
        """
        ListColumn - a model defined in Swagger
        """

        self.container['totals_calculation'] = None
        self.container['name'] = None
        self.container['formula'] = None
        self.container['range'] = None

        if totals_calculation is not None:
          self.totals_calculation = totals_calculation
        if name is not None:
          self.name = name
        if formula is not None:
          self.formula = formula
        if range is not None:
          self.range = range

    @property
    def totals_calculation(self):
        """
        Gets the totals_calculation of this ListColumn.
        Gets and sets the type of calculation in the Totals row of the list column.

        :return: The totals_calculation of this ListColumn.
        :rtype: str
        """
        return self.container['totals_calculation']

    @totals_calculation.setter
    def totals_calculation(self, totals_calculation):
        """
        Sets the totals_calculation of this ListColumn.
        Gets and sets the type of calculation in the Totals row of the list column.

        :param totals_calculation: The totals_calculation of this ListColumn.
        :type: str
        """

        self.container['totals_calculation'] = totals_calculation

    @property
    def name(self):
        """
        Gets the name of this ListColumn.
        Gets and sets the name of the column.

        :return: The name of this ListColumn.
        :rtype: str
        """
        return self.container['name']

    @name.setter
    def name(self, name):
        """
        Sets the name of this ListColumn.
        Gets and sets the name of the column.

        :param name: The name of this ListColumn.
        :type: str
        """

        self.container['name'] = name

    @property
    def formula(self):
        """
        Gets the formula of this ListColumn.
        Gets and sets the formula of the list column.

        :return: The formula of this ListColumn.
        :rtype: str
        """
        return self.container['formula']

    @formula.setter
    def formula(self, formula):
        """
        Sets the formula of this ListColumn.
        Gets and sets the formula of the list column.

        :param formula: The formula of this ListColumn.
        :type: str
        """

        self.container['formula'] = formula

    @property
    def range(self):
        """
        Gets the range of this ListColumn.
        Gets and sets the formula of the list column.

        :return: The range of this ListColumn.
        :rtype: Range
        """
        return self.container['range']

    @range.setter
    def range(self, range):
        """
        Sets the range of this ListColumn.
        Gets and sets the formula of the list column.

        :param range: The range of this ListColumn.
        :type: Range
        """

        self.container['range'] = range

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.get_swagger_types()):
            value = self.get_from_container(attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ListColumn):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
